//+------------------------------------------------------------------+
//|                                                 Range_Trader.mq4 |
//|                                         Copyright  2008,JP      |
//|                                      maurosandrade@yahoo.com.br  |
//| made for BELEKAS and Igroks Thread                               |
//| modified for use with the Igrok Method             |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Jupiter_Peak"
#property link      "maurosandrade@yahoo.com.br"

#property indicator_chart_window
//---- input parameters
extern double    Risk_to_Reward_ratio= 5.0;
extern int       Stop_Loss= 1;
extern int       DailyAverage = 60;
extern int       WeeklyAverage = 26;
extern int       MonthlyAverage = 24;
int nDigits;
extern bool      SkipSundays = true;
extern bool      SkipTradeText = true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   if(Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD")  nDigits = 3;
   else nDigits = 5;

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment( "" );
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //----
   string PIPS="";
   int R1=0,MR25=0,WR25=0,R25=0,R40=0,RAvg=0;
   int Prevday=0,Prevwk=0,Prevmthy=0;
   int Curday=0,Curwk=0,Curmthy=0;
   double CurrentSpread=0;
   int EntryLong=0,EntryShort=0,StopLoss_Long=0,StopLoss_Short=0,today_range=0,RoomDown=0,TPLong=0,TPShort=0,TotalPips=0;
   double   SL_Long=0,SL_Short=0,ENT_Long=0,ENT_Short,TP_Long=0,TP_Short=0;
   double   low0=0,high0=0, low1=0,high1=0, lowWeek1=0,highWeek1=0, lowMonth1=0,highMonth1=0, highYear1=0,lowYear1=0;
   string   Text="";
   int i=0;
   // get daily open
   double OPEN = iOpen(NULL,PERIOD_D1,0);
   // get current Close for today
   double CLOSE = iClose(NULL,PERIOD_D1,0);
   PIPS =  DoubleToStr((CLOSE-OPEN)/Point*0.1,0);
   
   // Calculate today's range   
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point*0.1;
   
   // Calculate total ranges for 25 days 26 wks 25 months
   for(i=1;i<=DailyAverage;i++)
      R25   =    R25 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point*0.1;
   for(i=1;i<=WeeklyAverage;i++)
      WR25   =    WR25 +  (iHigh(NULL,PERIOD_W1,i)-iLow(NULL,PERIOD_W1,i))/Point*0.1;
   for(i=1;i<=MonthlyAverage;i++)
      MR25   =    MR25 +  (iHigh(NULL,PERIOD_MN1,i)-iLow(NULL,PERIOD_MN1,i))/Point*0.1;

Prevday =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point*0.1;
Prevwk =  (iHigh(NULL,PERIOD_W1,1)-iLow(NULL,PERIOD_W1,1))/Point*0.1;
Prevmthy =  (iHigh(NULL,PERIOD_MN1,1)-iLow(NULL,PERIOD_MN1,1))/Point*0.1;

Curday =  (iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/Point*0.1;
Curwk =  (iHigh(NULL,PERIOD_W1,0)-iLow(NULL,PERIOD_W1,0))/Point*0.1;
Curmthy = (iHigh(NULL,PERIOD_MN1,0)-iLow(NULL,PERIOD_MN1,0))/Point*0.1;

// Getting Main Move of the Day

   int dayshift = 0;
   if( SkipSundays && TimeDayOfWeek( iTime(NULL, PERIOD_D1, 0 ) ) == 0 ) dayshift = 1; //monday
   // get yesterday's high and low
   low1  =  iLow(NULL,PERIOD_D1,dayshift);
   high1 =  iHigh(NULL,PERIOD_D1,dayshift);
   
   // number of M1 bars today
   int numbarsM1today = iBarShift( NULL, PERIOD_M1, iTime(NULL, PERIOD_D1, 0 ));
   // go back through today, find todays high or low whichever first, ranging if not broken
   bool mainMoveRange = true;
   bool mainMoveUp = false;
   for( int k=0;k<=numbarsM1today;k++ )
   if( iLow(NULL, PERIOD_M1, k ) == low1 ) { mainMoveRange = false; mainMoveUp = false; break; }
   else
   if( iHigh(NULL, PERIOD_M1, k ) == high1 ) { mainMoveRange = false; mainMoveUp = true; break; }
   string dayMove = "Main move of the day is ";
   if( mainMoveRange == true ) dayMove = dayMove + "RANGING"; else
   if( mainMoveUp == true ) dayMove = dayMove + "UP"; else dayMove = dayMove + "DOWN";   

// Getting Main Move of the Week
   
   int weekshift = 0;
   lowWeek1 = iLow (NULL,PERIOD_W1,weekshift);
   highWeek1 = iHigh (NULL,PERIOD_W1,weekshift);
   
   // number of M1 bars this week
   int numbarsM1week = iBarShift (NULL, PERIOD_M1, iTime(NULL, PERIOD_W1, 0));
   bool mainWMoveRange = true;
   bool mainWMoveUp = false;
   for( int q=0;q<=numbarsM1week;q++ )
   if( iLow(NULL, PERIOD_M1, q ) == lowWeek1 ) { mainWMoveRange = false; mainWMoveUp = false; break; }
   else
   if( iHigh(NULL, PERIOD_M1, q ) == highWeek1 ) { mainWMoveRange = false; mainWMoveUp = true; break; }
   string weekMove = "Main move of the week is ";
   if( mainWMoveRange == true ) weekMove = weekMove + "RANGING"; else
   if( mainWMoveUp == true ) weekMove = weekMove + "UP"; else weekMove = weekMove + "DOWN";
   
// Getting Main Move of the Month

   int monthshift = 0;
   lowMonth1 = iLow (NULL,PERIOD_MN1,monthshift);
   highMonth1 = iHigh (NULL,PERIOD_MN1,monthshift);
   
   // number of H1 bars this month
   int numbarsH1month = iBarShift (NULL, PERIOD_H1, iTime(NULL, PERIOD_MN1, 0));
   bool mainMMoveRange = true;
   bool mainMMoveUp = false;
   for( int p=0;p<=numbarsH1month;p++ )
   if( iLow(NULL, PERIOD_H1, p ) == lowMonth1 ) { mainMMoveRange = false; mainMMoveUp = false; break; }
   else
   if( iHigh(NULL, PERIOD_H1, p ) == highMonth1 ) { mainMMoveRange = false; mainMMoveUp = true; break; }
   string monthMove = "Main move of the month is ";
   if( mainMMoveRange == true ) monthMove = monthMove + "RANGING"; else
   if( mainMMoveUp == true ) monthMove = monthMove + "UP"; else monthMove = monthMove + "DOWN";

// Getting Main Move of the Year
   
   //get high and low of year and time of first daily bar
   datetime FirstDayTime;
   for ( int r=1;r<= Month();r++ )
   FirstDayTime = iTime(NULL,PERIOD_MN1,r-1) ;
   int numbarsD1year = iBarShift (NULL, PERIOD_D1, FirstDayTime, 0);
   highYear1 = iHigh (NULL,PERIOD_D1, iHighest (NULL,PERIOD_D1,MODE_HIGH,numbarsD1year,0));
   lowYear1 = iLow (NULL,PERIOD_D1,iLowest(NULL,PERIOD_D1,MODE_LOW,numbarsD1year,0));
   
   bool mainYMoveRange = true;
   bool mainYMoveUp = false;
   for( int s=0;s<=numbarsD1year;s++ )
   if( iLow(NULL, PERIOD_D1, s ) == lowYear1 ) { mainYMoveRange = false; mainYMoveUp = false; break; }
   else
   if( iHigh(NULL, PERIOD_D1, s ) == highYear1 ) { mainYMoveRange = false; mainYMoveUp = true; break; }
   string yearMove = "Main move of the year is ";
   if( mainYMoveRange == true ) yearMove = yearMove + "RANGING"; else
   if( mainYMoveUp == true ) yearMove = yearMove + "UP"; else yearMove = yearMove + "DOWN";
   
   // Calculate average ranges   
   R25 = R25/DailyAverage;
   WR25 = WR25/WeeklyAverage;
   MR25 = MR25/MonthlyAverage;
   
   // Calculate long and short trades
   // Get todays high and low
   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   // calculate risk/reward units in terms of average daily range
   TotalPips = R25/Risk_to_Reward_ratio;
   // long entry at days low + one risk/reward unit - Stop loss
   EntryLong = TotalPips*10 - Stop_Loss*10;
   ENT_Long = low0 + EntryLong*Point;
   SL_Long    =  low0 - Stop_Loss*Point*10;
   //TP at entry + average range
   TPLong =  EntryLong + R25*10; 
   TP_Long = ENT_Long + TPLong*Point;
   // short entry at days high - one risk/reward unit - Stop loss
   EntryShort =  TotalPips*10 - Stop_Loss*10;
   ENT_Short  =  high0 - EntryShort*Point;
   SL_Short   =  high0 + Stop_Loss*Point*10;
   TPShort = R25*10 + high0 - EntryShort;
   TP_Short = ENT_Short - TPShort*Point;
   
   CurrentSpread = (Ask/Point*0.1)-(Bid/Point*0.1);

   today_range = (iHigh(NULL,PERIOD_D1,0)) - (iLow(NULL,PERIOD_D1,0));

   Text =   "Avg " + DailyAverage + " Days Range: " +  R25  + "\n" +
            "Prev Day Range: " +  Prevday  + "\n" +
            "Current Day Range: " +  Curday  + "\n\n" +
            "Avg " + WeeklyAverage + " Weeks Range: " +  WR25  + "\n" +
            "Prev Week Range: " +  Prevwk  + "\n" +
            "Current Week Range: " +  Curwk  + "\n\n" +
            "Avg " + MonthlyAverage + " Months Range: " +  MR25  + "\n" +
            "Prev Month Range: " +  Prevmthy  + "\n" +
            "Current Month Range: " +  Curmthy  + "\n" +
            "Currency Pair spread: " +  DoubleToStr(CurrentSpread,1)  + "\n\n" +
            dayMove + "\n" +
            weekMove + "\n" + monthMove + "\n" + yearMove + "\n\n";
            
   if (SkipTradeText == false)Text =   Text +
            "Long Entry: " + DoubleToStr(EntryLong*0.1,0) + " Pips at " + DoubleToStr(ENT_Long,nDigits)  + "\n" +        
            "Short Entry: " + DoubleToStr(EntryShort*0.1,0) + " Pips at " + DoubleToStr(ENT_Short,nDigits)  + "\n\n" +
            "StopLosses should be :"  + "\n" +
            "Long:  " + Stop_Loss  + " Pips at " + DoubleToStr(SL_Long,nDigits)  + "\n" +
            "Short: " + Stop_Loss + " Pips at " + DoubleToStr(SL_Short,nDigits) + "\n\n" +
            "Take Profits should be :"  + "\n" +
            "Long:  " + DoubleToStr(TPLong*0.1,0) + " Pips at " + DoubleToStr(TP_Long,nDigits)  + "\n" +
            "Short: " + DoubleToStr(TPShort*0.1,0) + " Pips at " + DoubleToStr(TP_Short,nDigits) + "\n\n" +
            "** Always Consider Spread on Pair Before Entering **" + "\n\n"; 
            
  
   Comment(Text);

   return(0);
  }
//+------------------------------------------------------------------+